-------------------------------------------
--- Author: Ketho (EU-Boulderfist)		---
--- License: Public Domain				---
--- Created: 2011.05.01					---
--- Version: v0.6 [2011.11.18]			---
-------------------------------------------
--- Curse			http://www.curse.com/addons/wow/removecountdown
--- WoWInterface	http://www.wowinterface.com/downloads/info19743-RemoveCountdown.html

local VERSION = 0.6
local NAME = "RemoveCountdown"
local L = LibStub("AceLocale-3.0"):GetLocale("RemoveCountdown", true)
local db

	--------------------
	--- TimerTracker ---
	--------------------

local function RefreshConfig()
	if db.numbers or db.timerbar then
		TimerTracker:RegisterEvent("START_TIMER")
	else
		TimerTracker:UnregisterEvent("START_TIMER")
	end
end

-- Blizzard provided StartTimer_BarOnlyOnUpdate which
-- apparently is currently unused, but very handy for us
local oldStartTimer_BigNumberOnUpdate = StartTimer_BigNumberOnUpdate

function StartTimer_BigNumberOnUpdate(...)
	if db.timerbar then
		StartTimer_BarOnlyOnUpdate(...)
	else
		oldStartTimer_BigNumberOnUpdate(...)
	end
end

	---------------
	--- Options ---
	---------------

local options = {
	type = "group",
	name = NAME.." |cffB6CA00v"..VERSION.."|r",
	args = {
		inline = {
			type = "group",
			name = " ",
			inline = true,
			args = {
				TimerBar = {
					type = "toggle",
					order = 1,
					width = "full",
					descStyle = "",
					name = " "..L["Timer Bar"],
					get = function(i) return db.timerbar end,
					set = function(i, v) db.timerbar = v; db.numbers = false; RefreshConfig() end,
				},
				TimerBarImg = {
					type = "description",
					order = 2,
					descStyle = "",
					name = "      |TInterface\\AddOns\\RemoveCountdown\\Images\\TimerBar:32:256|t\n",
				},
				Numbers = {
					type = "toggle",
					order = 3,
					width = "full",
					descStyle = "",
					name = " "..L["Numbers"],
					get = function(i) return db.numbers end,
					set = function(i, v) db.numbers = v; db.timerbar = false; RefreshConfig() end,
				},
				NumbersImg = {
					type = "description",
					order = 4,
					descStyle = "",
					name = "|TInterface\\Timer\\BigTimerNumbers:170:256|t",
				},
			},
		},
	},
}

	----------------------
	--- Initialization ---
	----------------------

local optionsFrame

local function OnEvent(self, event, ...)
	if event == "ADDON_LOADED" and ... == "RemoveCountdown" then
		RemoveCountdownDB2 = RemoveCountdownDB2 or {}
		db = RemoveCountdownDB2
		LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("RemoveCountdown", options)
		optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("RemoveCountdown", NAME)
		RefreshConfig()
		self:RegisterEvent("START_TIMER")
		self:UnregisterEvent("ADDON_LOADED")
	elseif event == "START_TIMER" then
		if db.numbers then
			-- removes TimerBar
			for i = 1, #TimerTracker.timerList do
				_G["TimerTrackerTimer"..i.."StatusBar"]:Hide()
			end
		end
	end
end

local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", OnEvent)

	---------------------
	--- Slash Command ---
	---------------------

SLASH_REMOVECOUNTDOWN1 = "/rmc"
SLASH_REMOVECOUNTDOWN2 = "/removecount"
SLASH_REMOVECOUNTDOWN3 = "/removecountdown"

SlashCmdList["REMOVECOUNTDOWN"] = function(msg, editbox)
	InterfaceOptionsFrame_OpenToCategory(optionsFrame)
end